Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 2548)
+++ .hgsubstate	(revision 2574)
@@ -1,1 +1,1 @@
-a51d747b2601fd10b50926a017e25764abe0c872 inc/libs/clearbricks
+5779e9453cf50ec3c90c6a260061c29d2ebac064 inc/libs/clearbricks
Index: admin/_charte.php
===================================================================
--- admin/_charte.php	(revision 2501)
+++ admin/_charte.php	(revision 2504)
@@ -31,4 +31,5 @@
 	<script type="text/javascript" src="js/jquery/jquery.js"></script>
 	<script type="text/javascript" src="js/jquery/jquery-ui.custom.js"></script>
+	<script type="text/javascript" src="js/jquery/jquery.ui.touch-punch.js"></script>
 	<script type="text/javascript" src="js/jquery/jquery.pageTabs.js"></script>
 	<script type="text/javascript" src="js/jquery/jquery.biscuit.js"></script>
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 2566)
+++ admin/categories.php	(revision 2567)
@@ -109,4 +109,5 @@
 	&& $rs->count()>1) {
 		$starting_script .= dcPage::jsLoad('js/jquery/jquery-ui.custom.js');
+		$starting_script .= dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js');
 		$starting_script .= dcPage::jsLoad('js/jquery/jquery.mjs.nestedSortable.js');
 }
Index: admin/js/jquery/jquery.ui.touch-punch.js
===================================================================
--- admin/js/jquery/jquery.ui.touch-punch.js	(revision 2495)
+++ admin/js/jquery/jquery.ui.touch-punch.js	(revision 2495)
@@ -0,0 +1,160 @@
+/*!
+ * jQuery UI Touch Punch 0.2.2
+ *
+ * Copyright 2011, Dave Furfero
+ * Dual licensed under the MIT or GPL Version 2 licenses.
+ *
+ * Depends:
+ *  jquery.ui.widget.js
+ *  jquery.ui.mouse.js
+ */
+(function ($) {
+
+  // Detect touch support
+  $.support.touch = 'ontouchend' in document;
+
+  // Ignore browsers without touch support
+  if (!$.support.touch) {
+    return;
+  }
+
+  var mouseProto = $.ui.mouse.prototype,
+      _mouseInit = mouseProto._mouseInit,
+      touchHandled;
+
+  /**
+   * Simulate a mouse event based on a corresponding touch event
+   * @param {Object} event A touch event
+   * @param {String} simulatedType The corresponding mouse event
+   */
+  function simulateMouseEvent (event, simulatedType) {
+
+    // Ignore multi-touch events
+    if (event.originalEvent.touches.length > 1) {
+      return;
+    }
+
+    event.preventDefault();
+
+    var touch = event.originalEvent.changedTouches[0],
+        simulatedEvent = document.createEvent('MouseEvents');
+    
+    // Initialize the simulated mouse event using the touch event's coordinates
+    simulatedEvent.initMouseEvent(
+      simulatedType,    // type
+      true,             // bubbles                    
+      true,             // cancelable                 
+      window,           // view                       
+      1,                // detail                     
+      touch.screenX,    // screenX                    
+      touch.screenY,    // screenY                    
+      touch.clientX,    // clientX                    
+      touch.clientY,    // clientY                    
+      false,            // ctrlKey                    
+      false,            // altKey                     
+      false,            // shiftKey                   
+      false,            // metaKey                    
+      0,                // button                     
+      null              // relatedTarget              
+    );
+
+    // Dispatch the simulated event to the target element
+    event.target.dispatchEvent(simulatedEvent);
+  }
+
+  /**
+   * Handle the jQuery UI widget's touchstart events
+   * @param {Object} event The widget element's touchstart event
+   */
+  mouseProto._touchStart = function (event) {
+
+    var self = this;
+
+    // Ignore the event if another widget is already being handled
+    if (touchHandled || !self._mouseCapture(event.originalEvent.changedTouches[0])) {
+      return;
+    }
+
+    // Set the flag to prevent other widgets from inheriting the touch event
+    touchHandled = true;
+
+    // Track movement to determine if interaction was a click
+    self._touchMoved = false;
+
+    // Simulate the mouseover event
+    simulateMouseEvent(event, 'mouseover');
+
+    // Simulate the mousemove event
+    simulateMouseEvent(event, 'mousemove');
+
+    // Simulate the mousedown event
+    simulateMouseEvent(event, 'mousedown');
+  };
+
+  /**
+   * Handle the jQuery UI widget's touchmove events
+   * @param {Object} event The document's touchmove event
+   */
+  mouseProto._touchMove = function (event) {
+
+    // Ignore event if not handled
+    if (!touchHandled) {
+      return;
+    }
+
+    // Interaction was not a click
+    this._touchMoved = true;
+
+    // Simulate the mousemove event
+    simulateMouseEvent(event, 'mousemove');
+  };
+
+  /**
+   * Handle the jQuery UI widget's touchend events
+   * @param {Object} event The document's touchend event
+   */
+  mouseProto._touchEnd = function (event) {
+
+    // Ignore event if not handled
+    if (!touchHandled) {
+      return;
+    }
+
+    // Simulate the mouseup event
+    simulateMouseEvent(event, 'mouseup');
+
+    // Simulate the mouseout event
+    simulateMouseEvent(event, 'mouseout');
+
+    // If the touch interaction did not move, it should trigger a click
+    if (!this._touchMoved) {
+
+      // Simulate the click event
+      simulateMouseEvent(event, 'click');
+    }
+
+    // Unset the flag to allow other widgets to inherit the touch event
+    touchHandled = false;
+  };
+
+  /**
+   * A duck punch of the $.ui.mouse _mouseInit method to support touch events.
+   * This method extends the widget with bound touch event handlers that
+   * translate touch events to mouse events and pass them to the widget's
+   * original mouse event handling methods.
+   */
+  mouseProto._mouseInit = function () {
+    
+    var self = this;
+
+    // Delegate the touch handlers to the widget's element
+    self.element
+      .bind('touchstart', $.proxy(self, '_touchStart'))
+      .bind('touchmove', $.proxy(self, '_touchMove'))
+      .bind('touchend', $.proxy(self, '_touchEnd'));
+
+    // Call the original $.ui.mouse init method
+    _mouseInit.call(self);
+  };
+
+})(jQuery);
Index: admin/langs.php
===================================================================
--- admin/langs.php	(revision 2573)
+++ admin/langs.php	(revision 2566)
@@ -89,7 +89,7 @@
 		@unlink($dest);
 		if ($ret_code == 2) {
-			dcPage::addSuccessNotice(__('Language has been successfully upgraded'));
+			dcPage::addSuccessNotice( __('Language has been successfully upgraded'));
 		} else {
-			dcPage::addSuccessNotice(__('Language has been successfully installed.'));
+			dcPage::addSuccessNotice($__('Language has been successfully installed.'));
 		}
 		http::redirect('langs.php');
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 2566)
+++ admin/preferences.php	(revision 2567)
@@ -305,4 +305,5 @@
 	($user_acc_nodragdrop ? '' : dcPage::jsLoad('js/_preferences-dragdrop.js')).
 	dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+	dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 	dcPage::jsLoad('js/jquery/jquery.pwstrength.js').
 		'<script type="text/javascript">'."\n".
Index: admin/services.php
===================================================================
--- admin/services.php	(revision 2572)
+++ admin/services.php	(revision 2566)
@@ -399,5 +399,5 @@
 		while ($rs->fetch())
 		{
-			if (stripos($rs->meta_id,$q) === 0) {
+			if (preg_match('/'.$q.'/i',$rs->meta_id)) {
 				$metaTag = new xmlTag('meta');
 				$metaTag->type = $rs->meta_type;
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 2566)
+++ inc/core/class.dc.blog.php	(revision 2567)
@@ -1894,5 +1894,5 @@
 	- post_id: (integer) Get comments belonging to given post_id
 	- cat_id: (integer or array) Get comments belonging to entries of given category ID
-	- comment_id: (integer) Get comment with given ID
+	- comment_id: (integer or array) Get comment with given ID (or IDs)
 	- comment_site: (string) Get comments with given comment_site
 	- comment_status: (integer) Get comments with given comment_status
@@ -1984,5 +1984,10 @@
 
 		if (isset($params['comment_id']) && $params['comment_id'] !== '') {
-			$strReq .= 'AND comment_id = '.(integer) $params['comment_id'].' ';
+			if (is_array($params['comment_id'])) {
+				array_walk($params['comment_id'],create_function('&$v,$k','if($v!==null){$v=(integer)$v;}'));
+			} else {
+				$params['comment_id'] = array((integer) $params['comment_id']);
+			}
+			$strReq .= 'AND comment_id '.$this->con->in($params['comment_id']);
 		}
 
Index: inc/core/class.dc.namespace.php
===================================================================
--- inc/core/class.dc.namespace.php	(revision 2566)
+++ inc/core/class.dc.namespace.php	(revision 2567)
@@ -125,4 +125,34 @@
 
 	/**
+	Returns global setting value if exists.
+
+	@param	n		<b>string</b>		setting name
+	@return	<b>mixed</b>
+	*/
+	public function getGlobal($n)
+	{
+		if (isset($this->global_settings[$n]['value'])) {
+			return $this->global_settings[$n]['value'];
+		}
+
+		return null;
+	}
+
+	/**
+	Returns local setting value if exists.
+
+	@param	n		<b>string</b>		setting name
+	@return	<b>mixed</b>
+	*/
+	public function getLocal($n)
+	{
+		if (isset($this->local_settings[$n]['value'])) {
+			return $this->local_settings[$n]['value'];
+		}
+
+		return null;
+	}
+
+	/**
 	Magic __get method.
 	@copydoc ::get
Index: inc/core/class.dc.themes.php
===================================================================
--- inc/core/class.dc.themes.php	(revision 2566)
+++ inc/core/class.dc.themes.php	(revision 2567)
@@ -59,5 +59,5 @@
 		# Themes specifics properties
 		$properties = array_merge(
-			array('parent' => null),
+			array('parent' => null, 'tplset' => 'legacy'),
 			$properties,
 			array('permissions' => 'admin') // force themes perms
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2566)
+++ inc/prepend.php	(revision 2567)
@@ -135,5 +135,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.6.1');
+define('DC_VERSION','2.7-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 2566)
+++ inc/public/class.dc.template.php	(revision 2574)
@@ -234,102 +234,4 @@
 	}
 
-	protected function compileFile($file)
-	{
-		$fc = file_get_contents($file);
-
-		$this->compile_stack[] = $file;
-
-		# Remove every PHP tags
-		if ($this->remove_php)
-		{
-			$fc = preg_replace('/<\?(?=php|=|\s).*?\?>/ms','',$fc);
-		}
-
-		# Transform what could be considered as PHP short tags
-		$fc = preg_replace('/(<\?(?!php|=|\s))(.*?)(\?>)/ms',
-		'<?php echo "$1"; ?>$2<?php echo "$3"; ?>',$fc);
-
-		# Remove template comments <!-- #... -->
-		$fc = preg_replace('/(^\s*)?<!-- #(.*?)-->/ms','',$fc);
-
-		# Lexer part : split file into small pieces
-		# each array entry will be either a tag or plain text
-		$blocks = preg_split(
-			'#(<tpl:\w+[^>]*>)|(</tpl:\w+>)|({{tpl:\w+[^}]*}})#msu',$fc,-1,
-			PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);
-
-		# Next : build semantic tree from tokens.
-		$rootNode = new tplNode();
-		$node = $rootNode;
-		$errors = array();
-		foreach ($blocks as $id => $block) {
-			$isblock = preg_match('#<tpl:(\w+)(?:(\s+.*?)>|>)|</tpl:(\w+)>|{{tpl:(\w+)(\s(.*?))?}}#ms',$block,$match);
-			if ($isblock == 1) {
-				if (substr($match[0],1,1) == '/') {
-					// Closing tag, check if it matches current opened node
-					$tag = $match[3];
-					if (($node instanceof tplNodeBlock) && $node->getTag() == $tag) {
-						$node->setClosing();
-						$node = $node->getParent();
-					} else {
-						// Closing tag does not match opening tag
-						// Search if it closes a parent tag
-						$search = $node;
-						while($search->getTag() != 'ROOT' && $search->getTag() != $tag) {
-							$search = $search->getParent();
-						}
-						if ($search->getTag() == $tag) {
-							$errors[] = sprintf(
-								__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
-								html::escapeHTML($node->getTag()));
-							$search->setClosing();
-							$node = $search->getParent();
-						} else {
-							$errors[]=sprintf(
-								__('Unexpected closing tag </tpl:%s> found.'),
-								$tag);;
-						}
-					}
-				} elseif (substr($match[0],0,1) == '{') {
-					// Value tag
-					$tag = $match[4];
-					$str_attr = '';
-					$attr = array();
-					if (isset($match[6])) {
-						$str_attr = $match[6];
-						$attr = $this->getAttrs($match[6]);
-					}
-					$node->addChild(new tplNodeValue($tag,$attr,$str_attr));
-				} else {
-					// Opening tag, create new node and dive into it
-					$tag = $match[1];
-					$newnode = new tplNodeBlock($tag,isset($match[2])?$this->getAttrs($match[2]):array());
-					$node->addChild($newnode);
-					$node = $newnode;
-				}
-			} else {
-				// Simple text
-				$node->addChild(new tplNodeText($block));
-			}
-		}
-
-		if (($node instanceof tplNodeBlock) && !$node->isClosed()) {
-			$errors[] = sprintf(
-				__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
-				html::escapeHTML($node->getTag()));
-		}
-
-		$err = "";
-		if (count($errors) > 0) {
-			$err = "\n\n<!-- \n".
-				__('WARNING: the following errors have been found while parsing template file :').
-				"\n * ".
-				join("\n * ",$errors).
-				"\n -->\n";
-		}
-
-		return $rootNode->compile($this).$err;
-	}
-
 	public function compileBlockNode($tag,$attr,$content)
 	{
@@ -342,9 +244,5 @@
 		$this->core->callBehavior('templateInsideBlock',$this->core,$this->current_tag,$attr,array(&$content));
 
-		if (isset($this->blocks[$this->current_tag])) {
-			$res .= call_user_func($this->blocks[$this->current_tag],$attr,$content);
-		} elseif ($this->unknown_block_handler != null) {
-			$res .= call_user_func($this->unknown_block_handler,$this->current_tag,$attr,$content);
-		}
+		$res .= parent::compileBlockNode($this->current_tag,$attr,$content);
 
 		# --BEHAVIOR-- templateAfterBlock
@@ -362,9 +260,5 @@
 		$res = $this->core->callBehavior('templateBeforeValue',$this->core,$this->current_tag,$attr);
 
-		if (isset($this->values[$this->current_tag])) {
-			$res .= call_user_func($this->values[$this->current_tag],$attr,ltrim($str_attr));
-		} elseif ($this->unknown_value_handler != null) {
-			$res .= call_user_func($this->unknown_value_handler,$this->current_tag,$attr,$str_attr);
-		}
+		$res .= parent::compileValueNode($this->current_tag,$attr,$str_attr);
 
 		# --BEHAVIOR-- templateAfterValue
@@ -372,18 +266,4 @@
 
 		return $res;
-	}
-
-	public function setUnknownValueHandler($callback)
-	{
-		if (is_callable($callback)) {
-			$this->unknown_value_handler = $callback;
-		}
-	}
-
-	public function setUnknownBlockHandler($callback)
-	{
-		if (is_callable($callback)) {
-			$this->unknown_block_handler = $callback;
-		}
 	}
 
Index: inc/public/default-templates/legacy/rss2.xsl
===================================================================
--- inc/public/default-templates/legacy/rss2.xsl	(revision 2567)
+++ inc/public/default-templates/legacy/rss2.xsl	(revision 2567)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+xmlns:content="http://purl.org/rss/1.0/modules/content/"
+xmlns="http://www.w3.org/1999/xhtml">
+
+<xsl:output method="html"/>
+
+<xsl:template match="/">
+<html>
+  <head>
+    <title>{{tpl:lang Subscribe to}} <xsl:value-of select="/rss/channel/title"/></title>
+    <style type="text/css">
+    <![CDATA[
+    body {
+      font: 80% Verdana,Arial,sans-serif;
+      margin: 20px 0;
+      padding: 0 0;
+      background: #fff;
+      color: #000;
+    }
+    a { color: #039; }
+    h1, h2 { font-family: Arial,sans-serif; }
+    h1 { font-size: 160%; margin: 0; }
+    h2 { font-size: 140%; font-weight: bold; margin: 0.5em 0 0.2em 0; }
+    h2 a { text-decoration: none; }
+    p { margin: 0 0 0.5em 0; }
+    #page {
+      margin: 0 80px;
+    }
+    #top {
+      background: #036;
+      padding : 1em;
+      color: #fff;
+    }
+    #top a {
+      color: #fff;
+      text-decoration: none;
+    }
+    #what {
+      padding: 1em;
+      background: #eee;
+      border-bottom: 1px solid #000;
+      font-size: 80%;
+    }
+    #what p {
+      margin: 0 0 0.5em 0;
+    }
+    #footer {
+      border-top: 1px solid #000;
+    }
+    #items {
+      background: #fff;
+      color: inherit;
+    }
+    #items div {
+      margin: 0 0 1em 0;
+    }
+    ]]>
+    </style>
+    <script type="text/javascript"><![CDATA[
+    window.onload = function() {
+      document.getElementById('feedurl').value = window.location.href;
+
+      // Ugly but works ;)
+      var c = document.getElementsByTagName('div');
+      var t = '';
+      for (var i=0; c.length-i != 0; i++) {
+        if (c[i].className == 'item-content') {
+          if (c[i].textContent) {
+            t = c[i].textContent;
+          } else if (c[i].innerText) {
+            t = c[i].innerText;
+          } else {
+            t = '';
+          }
+
+          if (t) { c[i].innerHTML = t; }
+        }
+      }
+    };
+    ]]></script>
+  </head>
+  <body>
+    <div id="page">
+      <div id="top">
+        <h1><a href="{/rss/channel/link}"><xsl:value-of select="/rss/channel/title"/></a></h1>
+        <p><xsl:value-of select="/rss/channel/description"/></p>
+      </div>
+      <div id="what">
+      <h3>{{tpl:lang What is an RSS feed?}}</h3>
+      <p>{{tpl:lang RSS feed is a free blog summary. It provides content
+      (either posts or comments) or  summaries of content, together with links
+      to the full versions, and other metadata. The last published items may
+      then be read by your favorite RSS
+      <a href="http://en.wikipedia.org/wiki/Aggregator">aggregator</a>.}}</p>
+      <h3>{{tpl:lang Subscribe}}</h3>
+      <p>{{tpl:lang Simply copy the following URL into your aggregator:}}</p>
+      <p><input type="text" size="60" value="" id="feedurl" /></p>
+      </div>
+      <div id="items">
+        <xsl:apply-templates select="//item"/>
+      </div>
+      <div id="footer">
+        <p><xsl:value-of select="/rss/channel/copyright"/></p>
+      </div>
+    </div>
+  </body>
+</html>
+</xsl:template>
+
+<!-- Item template -->
+<xsl:template match="item">
+  <div>
+    <h2><a href="{link}"><xsl:value-of select="title"/></a></h2>
+    <div class="item-content"><xsl:value-of select="description" /></div>
+  </div>
+</xsl:template>
+
+</xsl:stylesheet>
Index: inc/public/prepend.php
===================================================================
--- inc/public/prepend.php	(revision 2566)
+++ inc/public/prepend.php	(revision 2567)
@@ -134,10 +134,15 @@
 	$__theme_tpl_path[] = $core->blog->themes_path.'/'.$__parent_theme.'/tpl';
 }
-
-$core->tpl->setPath(
-	$__theme_tpl_path,
-	dirname(__FILE__).'/default-templates',
-	$core->tpl->getPath());
-
+$tplset = $core->themes->moduleInfo($core->blog->settings->system->theme,'tplset');
+if (!empty($tplset) && is_dir(dirname(__FILE__).'/default-templates/'.$tplset)) {
+	$core->tpl->setPath(
+		$__theme_tpl_path,
+		dirname(__FILE__).'/default-templates/'.$tplset,
+		$core->tpl->getPath());
+} else {
+	$core->tpl->setPath(
+		$__theme_tpl_path,
+		$core->tpl->getPath());
+}
 $core->url->mode = $core->blog->settings->system->url_scan;
 
Index: plugins/antispam/filters/class.dc.filter.linkslookup.php
===================================================================
--- plugins/antispam/filters/class.dc.filter.linkslookup.php	(revision 2566)
+++ plugins/antispam/filters/class.dc.filter.linkslookup.php	(revision 2567)
@@ -48,4 +48,8 @@
 
 			$i = count($domain_elem) - 1;
+			if ($i == 0) {
+				// "domain" is 1 word long, don't check it
+				return null;
+			}
 			$host = $domain_elem[$i];
 			do
Index: plugins/antispam/index.php
===================================================================
--- plugins/antispam/index.php	(revision 2566)
+++ plugins/antispam/index.php	(revision 2567)
@@ -117,4 +117,5 @@
 	echo
 		dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+		dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 		dcPage::jsLoad('index.php?pf=antispam/antispam.js');
   }
Index: plugins/blogroll/index.php
===================================================================
--- plugins/blogroll/index.php	(revision 2566)
+++ plugins/blogroll/index.php	(revision 2567)
@@ -177,4 +177,5 @@
 	echo
 		dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+		dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 		dcPage::jsLoad('index.php?pf=blogroll/blogroll.js');
 	}
Index: plugins/pages/list.php
===================================================================
--- plugins/pages/list.php	(revision 2566)
+++ plugins/pages/list.php	(revision 2567)
@@ -55,5 +55,7 @@
   <title><?php echo __('Pages'); ?></title>
   <?php
-  	echo dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+  	echo
+  		dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+		dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 		dcPage::jsLoad('index.php?pf=pages/list.js').
 		'<script type="text/javascript">'.
Index: plugins/simpleMenu/index.php
===================================================================
--- plugins/simpleMenu/index.php	(revision 2455)
+++ plugins/simpleMenu/index.php	(revision 2496)
@@ -347,4 +347,5 @@
 			echo
 				dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+				dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 				dcPage::jsLoad('index.php?pf=simpleMenu/simplemenu.js');
 		}
Index: plugins/widgets/index.php
===================================================================
--- plugins/widgets/index.php	(revision 2509)
+++ plugins/widgets/index.php	(revision 2520)
@@ -218,4 +218,5 @@
 		echo
 			dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+			dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 			dcPage::jsLoad('index.php?pf=widgets/widgets.js');
   ?>
@@ -366,5 +367,5 @@
 		$altUp = $i == 0 ? ' alt=""' : ' alt="'.__('Up the widget').'"';
 		$altDown = $i == count($widgets->elements())-1 ? ' alt=""' : ' alt="'.__('Down the widget').'"';
-
+		
 		$iname = 'w['.$pr.']['.$i.']';
 
Index: themes/ductile/_prepend.php
===================================================================
--- themes/ductile/_prepend.php	(revision 2566)
+++ themes/ductile/_prepend.php	(revision 2567)
@@ -26,5 +26,6 @@
 		if (!$core->auth->user_prefs->accessibility->nodragdrop) {
 			echo
-				dcPage::jsLoad('js/jquery/jquery-ui.custom.js');
+				dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+				dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js');
 				echo <<<EOT
 <script type="text/javascript">
